#include <nemo/stralloc.h>
#include <nemo/djbio.h>
#include <nemo/error.h>
#include <nemo/djbiofd.h>
#include <nemo/getln.h>
#include <nemo/exit.h>

#include "mess822.h"
#include "die.h"

const char USAGE[] = "[name]";

static unsigned int flag;
static sa_vector value = SA_VECTOR;

static mess822_action a[] = {
/*  name       flag   c  value   a  w  */
  { "subject", &flag, 0, &value, 0, 0 },
  { 0,         0,     0, 0,      0, 0 }
};

static stralloc line = STRALLOC;

int main(int argc, char **argv)
{
  unsigned int i;

  PROGRAM = argv[0];
  if (argc > 2) die_usage();
  if (argc == 2) {
    a[0].name = argv[1];
  }
  if (!mess822_slurp_headers(djbiofd_insmall, &line, a)) {
    if (errno == error_proto) die_proto();
    if (errno == error_nomem) die_nomem();
    die_read("input");
  }
  for (i = 0; i < value.len; i++) {
    djbio_putsa(djbiofd_outsmall, &value.va[i]);
    djbio_putsflush(djbiofd_outsmall, "\n");
  }
  _exit(flag ? 0 : 100);
}
