#include <nemo/stralloc.h>

#include "mess822.h"

static const char colon[] = { ":" };
static const char space[] = { " " };

unsigned int mess822_date(const mess822_time *when, stralloc *out)
{
  register const struct caltime *t;
  long i;
  char buffer[8];

  if (!stralloc_erase(out)) return 0;

  if (!when->known) return 1;

  t = &when->ct;
/*
  if (!stralloc_catb(out, buffer, caldate_fmt_dow(&t->date, buffer))) return 0;
  if (!stralloc_append(out, ",")) return 0;
  if (!stralloc_append(out, space)) return 0;
*/
  if (!stralloc_catint(out, t->date.day)) return 0;
  if (!stralloc_append(out, space)) return 0;

  if (!stralloc_catb(out, buffer, caldate_fmt_month(&t->date, buffer))) return 0;
  if (!stralloc_append(out, space)) return 0;

  if (!stralloc_catlong(out, t->date.year)) return 0;
  if (!stralloc_append(out, space)) return 0;

  if (!stralloc_catint0(out, t->hour, 2)) return 0;
  if (!stralloc_append(out, colon)) return 0;
  if (!stralloc_catint0(out, t->minute, 2)) return 0;
  if (!stralloc_append(out, colon)) return 0;
  if (!stralloc_catint0(out, t->second, 2)) return 0;
  if (!stralloc_append(out, space)) return 0;

  if (when->known == 1) {
    if (!stralloc_catb(out, "+0000", 5)) return 0;
  }
  else {
    i = t->offset;
    if (i < 0) {
      if (!stralloc_append(out, "-")) return 0;
      i = -i;
    }
    else {
      if (!stralloc_append(out, "+")) return 0;
    }
    if (!stralloc_catint0(out, (int) (i / 60), 2)) return 0;
    if (!stralloc_catint0(out, (int) (i % 60), 2)) return 0;
  }

  return 1;
}
