#include "mess822.h"

unsigned int mess822_end(mess822_header *h)
{
  static mess822_addrlist addrlist = MESS822_ADDRLIST;
  static stralloc value = STRALLOC;

  mess822_action *a;
  unsigned int pos;
  char ch;

  if (!h->inprogress.len) {
    return 1;
  }
/*
  find first colon or other term char
*/
  for (pos = 0; pos < h->inprogress.len; ++pos) {
    ch = h->inprogress.s[pos];
    if (ch == ':') break;
    if (ch < 33) break;
    if (ch > 126) break;
  }
  if (!stralloc_copyb(&value, h->inprogress.s, pos)) return 0;
  stralloc_lower(&value);
/*
  scan excludes
*/
  if ((*h->exclude)(&value)) {
    if (!stralloc_erase(&h->inprogress)) return 0;
    return 1;
  }
/*
  scan for keyword
*/
  for (a = h->action; a->name; ++a) {
    if (stralloc_equals(&value, a->name)) {
      break;
    }
  }
/*
  should have keyword entry or last entry of keyword list
*/
/*
  skip white space
*/
  while (pos < h->inprogress.len) {
    ch = h->inprogress.s[pos];
    if ((ch != ' ') && (ch != '\t') && (ch != '\n')) break;
    ++pos;
  }
/*
  if colon - skip over it
*/
  if (pos < h->inprogress.len) {
    if (h->inprogress.s[pos] == ':') {
      ++pos;
    }
  }
/*
  skip white space
*/
  while (pos < h->inprogress.len) {
    ch = h->inprogress.s[pos];
    if ((ch != ' ') && (ch != '\t') && (ch != '\n')) break;
    ++pos;
  }
  /* XXX: allocate all necessary memory before doing anything? */

  if (a->flag) {
    *a->flag = 1;
  }

  if (a->copy) {
    if (!sa_vector_append(a->copy, &h->inprogress)) return 0;
  }
/*
  copy value into own variable - keep it simple
*/
  if (!stralloc_copyb(&value, h->inprogress.s + pos, h->inprogress.len - pos)) return 0;
/*
  convert tabs & newlines to spaces and delete trailing spaces
*/
  stralloc_replace(&value, '\t', ' ');
  stralloc_replace(&value, '\n', ' ');
  stralloc_trim(&value, " ", 1);

  if (a->value) {
    if (!sa_vector_append(a->value, &value)) return 0;
  }

  /* XXX: tokenize once for both addr and when? */

  if (a->addr) {
    if (!mess822_addrlist_scan(&addrlist, &value)) return 0;
    if (!mess822_addrlist_cat(a->addr, &addrlist)) return 0;
  }

  if (a->when) {
    if (!mess822_when(a->when, &value)) return 0;
  }

  if (!stralloc_erase(&h->inprogress)) return 0;

  return 1;
}
