#include "mess822.h"

unsigned int mess822_quotelist(stralloc *out, const mess822_addrlist *list)
{
  static stralloc comment = STRALLOC;

  mess822_addrdata *item;
  unsigned int last;
  unsigned int j;
  char type;

  if (!stralloc_erase(out)) return 0;
  if (!list->len) return 1;
  if (!stralloc_erase(&comment)) return 0;
  last = list->len - 1;
  type = ' ';
  for (j = 0; j <= last; ++j) {
    item = &list->ad[j];
    type = item->type;
    if (type == '(') {
      if (!stralloc_copy(&comment, &item->data)) return 0;
      continue;
    }
    if (type == ':') {
      if (comment.len) {
        if (!mess822_encode_data(out, comment.s, comment.len, "\"", "\"")) return 0;
        comment.len = 0;
      }
      if (!stralloc_cats(out, ": ")) return 0;
      continue;
    }
    if (type == ';') {  /* end of group list */
      stralloc_trim(out, ",\n ", 3);  /* remove trailing ',', ' ', '\n' chars */
      if (!stralloc_cats(out, " ;")) return 0;
    }
    else if (type == '@') {
      if (!mess822_quoteplus(out, &item->data, &comment)) return 0;
      comment.len = 0;
    }
    if (j != last) {
      if (!stralloc_cats(out, ",\n  ")) return 0;
    }
  }
  if (comment.len) {
    if (!mess822_encode_data(out, comment.s, comment.len, "\"", "\"")) return 0;
    if (!stralloc_cats(out, ": ;")) return 0;
  }

  return 1;
}
