#include <nemo/djbio.h>
#include <nemo/getln.h>

#include "mess822.h"

unsigned int mess822_slurp_headers(djbio *in, stralloc *line, mess822_action *a)
{
  static mess822_header h = MESS822_HEADER;
  unsigned int match;
  match = 0;
  if (!mess822_begin(&h, a)) return 0;
  for (;;) {
    if (getln_max(in, line, &match, '\n', MESS822_MAX_LINE_LENGTH) == -1) return 0;
    stralloc_trim(line, "\r\n", 2);
    if (!stralloc_append(line, "\n")) return 0;
    if (!mess822_ok(line)) break;
    if (!mess822_line(&h, line)) return 0;
    if (!match) break;
  }
  if (!mess822_end(&h)) return 0;
  return 1;
}
